GNU bug report logs - #15682
24.3.50; `:link' in `defgroup' does not respect `mouse-1-click-follows-link'

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Drew Adams <drew.adams@HIDDEN>; merged with #52; dated Tue, 22 Oct 2013 15:29:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 15682 <at> debbugs.gnu.org:


Received: (at 15682) by debbugs.gnu.org; 27 Apr 2016 17:18:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 13:18:21 2016
Received: from localhost ([127.0.0.1]:50375 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avT6T-0004No-0I
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 13:18:21 -0400
Received: from aserp1040.oracle.com ([141.146.126.69]:45249)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>)
 id 1avT6Q-0004NR-Lk; Wed, 27 Apr 2016 13:18:18 -0400
Received: from aserv0022.oracle.com (aserv0022.oracle.com [141.146.126.234])
 by aserp1040.oracle.com (Sentrion-MTA-4.3.2/Sentrion-MTA-4.3.2) with ESMTP id
 u3RHICnQ013869
 (version=TLSv1 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
 Wed, 27 Apr 2016 17:18:12 GMT
Received: from userv0121.oracle.com (userv0121.oracle.com [156.151.31.72])
 by aserv0022.oracle.com (8.13.8/8.13.8) with ESMTP id u3RHIB1U004165
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
 Wed, 27 Apr 2016 17:18:12 GMT
Received: from abhmp0005.oracle.com (abhmp0005.oracle.com [141.146.116.11])
 by userv0121.oracle.com (8.13.8/8.13.8) with ESMTP id u3RHIAIs008429;
 Wed, 27 Apr 2016 17:18:11 GMT
MIME-Version: 1.0
Message-ID: <3c72ce34-13d3-4ecd-8731-8408fa1a023a@default>
Date: Wed, 27 Apr 2016 10:18:09 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: RE: bug#15682: 24.3.50; `:link' in `defgroup' does not respect
 `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
 <87inz3hw40.fsf@HIDDEN> <89237c28-b7ed-4621-9baf-908fe99a6c9d@default>
 <87potbgfia.fsf@HIDDEN>
In-Reply-To: <87potbgfia.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9  (901082) [OL
 12.0.6744.5000 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Source-IP: aserv0022.oracle.com [141.146.126.234]
X-Spam-Score: -3.3 (---)
X-Debbugs-Envelope-To: 15682
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I kinda think it might be time to consider doing a rewrite from scratch
> using modern Emacs features, and then things like this bug report would
> start working automatically.
>=20
> How big a task would this be?  I mean, of course we'd keep compatibility
> (the defcustom language is fine), but just rewrite the UI `M-x
> customize' bits...  Hm...

I can't speak to this, sorry.  I'll just mention that I think:
(1) it could be a large undertaking and (2) there is existing
code out there that depends on or enhances cus*.el and wid*.el
code.

Personally, I would prefer that we live with it, and try to
improve it incrementally, rather than opting for a rewrite or
replacement.  I'd like to see a resident Emacs expert on wid*
and cus*, rather than someone who doesn't master it just trying
for a replacement.

(Yes, I'm conservative wrt this stuff.  Emacs is one of the
few things I'm conservative about. ;-))




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#15682; Package emacs. Full text available.

Message received at 15682 <at> debbugs.gnu.org:


Received: (at 15682) by debbugs.gnu.org; 27 Apr 2016 16:53:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 12:53:22 2016
Received: from localhost ([127.0.0.1]:50345 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avSiI-0000Sz-CK
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 12:53:22 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:46238)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1avSiG-0000Sm-EP; Wed, 27 Apr 2016 12:53:20 -0400
Received: from cm-84.215.1.64.getinternet.no ([84.215.1.64] helo=mouse)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>)
 id 1avSiD-0008Q2-Ld; Wed, 27 Apr 2016 18:53:19 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Drew Adams <drew.adams@HIDDEN>
Subject: Re: bug#15682: 24.3.50;
 `:link' in `defgroup' does not respect `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
 <87inz3hw40.fsf@HIDDEN>
 <89237c28-b7ed-4621-9baf-908fe99a6c9d@default>
Date: Wed, 27 Apr 2016 18:53:17 +0200
In-Reply-To: <89237c28-b7ed-4621-9baf-908fe99a6c9d@default> (Drew Adams's
 message of "Wed, 27 Apr 2016 09:24:34 -0700 (PDT)")
Message-ID: <87potbgfia.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 15682
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Drew Adams <drew.adams@HIDDEN> writes:

> Dunno.  But just because the code can be difficult to follow
> is not a reason to assume that it does unnecessary things, in
> general.  The widget code that I've been able to follow does
> DTRT, generally (AFAICT).

It does, but the logic is very hard to follow.  Custom/widget works by
inserting text into the buffer, and then "converting" it to a widget, or
by creating a widget and then inserting it.  And it does it all with
overlays, and seems like it's created its own event handling distinct
from the normal Emacs event handler, sort of.

There are, of course, historical reasons for this.  Per wrote Widget in
the mid 90s when many of these issues hadn't been resolved, and it
worked across many Emacs versions.

I kinda think it might be time to consider doing a rewrite from scratch
using modern Emacs features, and then things like this bug report would
start working automatically.

How big a task would this be?  I mean, of course we'd keep compatibility
(the defcustom language is fine), but just rewrite the UI `M-x
customize' bits...  Hm...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#15682; Package emacs. Full text available.

Message received at 15682 <at> debbugs.gnu.org:


Received: (at 15682) by debbugs.gnu.org; 27 Apr 2016 16:24:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 12:24:49 2016
Received: from localhost ([127.0.0.1]:50277 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avSGe-00089i-Qh
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 12:24:49 -0400
Received: from aserp1040.oracle.com ([141.146.126.69]:44793)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>)
 id 1avSGa-00089H-Tx; Wed, 27 Apr 2016 12:24:45 -0400
Received: from userv0022.oracle.com (userv0022.oracle.com [156.151.31.74])
 by aserp1040.oracle.com (Sentrion-MTA-4.3.2/Sentrion-MTA-4.3.2) with ESMTP id
 u3RGObO1001892
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Wed, 27 Apr 2016 16:24:37 GMT
Received: from userv0121.oracle.com (userv0121.oracle.com [156.151.31.72])
 by userv0022.oracle.com (8.14.4/8.13.8) with ESMTP id u3RGOa4C014598
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
 Wed, 27 Apr 2016 16:24:36 GMT
Received: from abhmp0005.oracle.com (abhmp0005.oracle.com [141.146.116.11])
 by userv0121.oracle.com (8.13.8/8.13.8) with ESMTP id u3RGOa37009821;
 Wed, 27 Apr 2016 16:24:36 GMT
MIME-Version: 1.0
Message-ID: <89237c28-b7ed-4621-9baf-908fe99a6c9d@default>
Date: Wed, 27 Apr 2016 09:24:34 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: RE: bug#15682: 24.3.50; `:link' in `defgroup' does not respect
 `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
 <87inz3hw40.fsf@HIDDEN>
In-Reply-To: <87inz3hw40.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9  (901082) [OL
 12.0.6744.5000 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Source-IP: userv0022.oracle.com [156.151.31.74]
X-Spam-Score: -3.3 (---)
X-Debbugs-Envelope-To: 15682
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I've had another peek at this,=20

Thanks for looking into it.

> but the main problem is that I don't quite understand why the
> Widget code is so...  complicated.

I sympathize, and I agree that is difficult to fathom.
Can't help with the understanding, however.

> Why does it do all the stuff below?  I mean, no other modes
> that react to mouse clicks need to ... do all that...

Dunno.  But just because the code can be difficult to follow
is not a reason to assume that it does unnecessary things, in
general.  The widget code that I've been able to follow does
DTRT, generally (AFAICT).

I doubt that anyone left understands the widget code well.
Maybe you can find Per Abrahamsen and get him to take a look?
The URLs for him listed here are dead, but maybe looking here
would be a start: https://www.emacswiki.org/emacs/PerAbrahamsen.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#15682; Package emacs. Full text available.

Message received at 15682 <at> debbugs.gnu.org:


Received: (at 15682) by debbugs.gnu.org; 27 Apr 2016 16:09:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 12:09:27 2016
Received: from localhost ([127.0.0.1]:50248 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avS1m-00068W-Rv
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 12:09:27 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:45625)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1avS1k-00068G-1x; Wed, 27 Apr 2016 12:09:25 -0400
Received: from cm-84.215.1.64.getinternet.no ([84.215.1.64] helo=mouse)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>)
 id 1avS1f-0007qU-T0; Wed, 27 Apr 2016 18:09:23 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Drew Adams <drew.adams@HIDDEN>
Subject: Re: bug#15682: 24.3.50;
 `:link' in `defgroup' does not respect `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
Date: Wed, 27 Apr 2016 18:09:19 +0200
In-Reply-To: <203eab8f-376f-423b-8347-3a0d354bb3e3@default> (Drew Adams's
 message of "Tue, 22 Oct 2013 08:28:06 -0700 (PDT)")
Message-ID: <87inz3hw40.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 15682
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Drew Adams <drew.adams@HIDDEN> writes:

> (defgroup foo nil
>   "..." :prefix "foo-" :group 'editing
>   :link '(url-link "http://www.emacswiki.org/"))
>
> (defcustom foobar t "..." :type 'boolean :group 'foo)
>
> M-x set-variable mouse-1-click-follows-link nil
> M-x customize-option foobar
>
> Click the link `http://www.emacswiki.org/' using `mouse-1'.  The link is
> followed - it should not be followed.
>
> Note that `mouse-on-link-p' returns `t' for positions on this link, and
> such positions have face `custom-link', property `follow-link' with
> value `mouse-face', and property `mouse-face' with a face value, all of
> which show further that the behavior violates the mandate of
> `mouse-1-click-follows-link'.

I've had another peek at this, but the main problem is that I don't
quite understand why the Widget code is so...  complicated.  Why does it
do all the stuff below?  I mean, no other modes that react to mouse
clicks need to ... do all that...

(defun widget-button-click (event)
  "Invoke the button that the mouse is pointing at."
  (interactive "e")
  (if (widget-event-point event)
      (let* ((oevent event)
	     (mouse-1 (memq (event-basic-type event) '(mouse-1 down-mouse-1)))
	     (pos (widget-event-point event))
	     (start (event-start event))
	     (button (get-char-property
		      pos 'button (and (windowp (posn-window start))
				       (window-buffer (posn-window start)))))
	     newpoint)
	(when (or (null button)
		  (catch 'button-press-cancelled
	      ;; Mouse click on a widget button.  Do the following
	      ;; in a save-excursion so that the click on the button
	      ;; doesn't change point.
	      (save-selected-window
		(select-window (posn-window (event-start event)))
		(save-excursion
		  (goto-char (posn-point (event-start event)))
		  (let* ((overlay (widget-get button :button-overlay))
			 (pressed-face (or (widget-get button :pressed-face)
					   widget-button-pressed-face))
			 (face (overlay-get overlay 'face))
			 (mouse-face (overlay-get overlay 'mouse-face)))


-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#15682; Package emacs. Full text available.
Merged 52 15682. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 22 Oct 2013 15:28:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 22 11:28:56 2013
Received: from localhost ([127.0.0.1]:35303 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1VYdt9-0008OO-E5
	for submit <at> debbugs.gnu.org; Tue, 22 Oct 2013 11:28:56 -0400
Received: from eggs.gnu.org ([208.118.235.92]:50239)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <drew.adams@HIDDEN>) id 1VYdt5-0008O8-Ur
 for submit <at> debbugs.gnu.org; Tue, 22 Oct 2013 11:28:52 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1VYdss-0002gZ-8u
 for submit <at> debbugs.gnu.org; Tue, 22 Oct 2013 11:28:46 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:36197)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1VYdss-0002gR-5P
 for submit <at> debbugs.gnu.org; Tue, 22 Oct 2013 11:28:38 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:51933)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1VYdsk-0002OQ-LK
 for bug-gnu-emacs@HIDDEN; Tue, 22 Oct 2013 11:28:38 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1VYdsd-0002bL-0H
 for bug-gnu-emacs@HIDDEN; Tue, 22 Oct 2013 11:28:30 -0400
Received: from aserp1040.oracle.com ([141.146.126.69]:28915)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1VYdsc-0002bG-Qi
 for bug-gnu-emacs@HIDDEN; Tue, 22 Oct 2013 11:28:22 -0400
Received: from acsinet21.oracle.com (acsinet21.oracle.com [141.146.126.237])
 by aserp1040.oracle.com (Sentrion-MTA-4.3.1/Sentrion-MTA-4.3.1) with ESMTP id
 r9MFSLD0019560
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK)
 for <bug-gnu-emacs@HIDDEN>; Tue, 22 Oct 2013 15:28:22 GMT
Received: from aserz7022.oracle.com (aserz7022.oracle.com [141.146.126.231])
 by acsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id r9MFSLXL020152
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
 for <bug-gnu-emacs@HIDDEN>; Tue, 22 Oct 2013 15:28:21 GMT
Received: from abhmt107.oracle.com (abhmt107.oracle.com [141.146.116.59])
 by aserz7022.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id r9MFSKvI017418
 for <bug-gnu-emacs@HIDDEN>; Tue, 22 Oct 2013 15:28:20 GMT
MIME-Version: 1.0
Message-ID: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
Date: Tue, 22 Oct 2013 08:28:06 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 24.3.50; `:link' in `defgroup' does not respect
 `mouse-1-click-follows-link'
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.8  (707110) [OL
 12.0.6680.5000 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Source-IP: acsinet21.oracle.com [141.146.126.237]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.4.x-2.6.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

emacs -Q

In *scratch*, evaluate this:

(defgroup foo nil
  "..." :prefix "foo-" :group 'editing
  :link '(url-link "http://www.emacswiki.org/"))

(defcustom foobar t "..." :type 'boolean :group 'foo)

M-x set-variable mouse-1-click-follows-link nil
M-x customize-option foobar

Click the link `http://www.emacswiki.org/' using `mouse-1'.  The link is
followed - it should not be followed.

Note that `mouse-on-link-p' returns `t' for positions on this link, and
such positions have face `custom-link', property `follow-link' with
value `mouse-face', and property `mouse-face' with a face value, all of
which show further that the behavior violates the mandate of
`mouse-1-click-follows-link'.

Quite annoying.  Emacs should not overrule user settings like this.
This is not a regression: it has been broken from the outset (broken in
all Emacs versions that support `:link').

In GNU Emacs 24.3.50.1 (i686-pc-mingw32)
 of 2013-10-19 on LEG570
Bzr revision: 114715 rgm@HIDDEN
Windowing system distributor `Microsoft Corp.', version 6.1.7601
Configured using:
 `configure --enable-checking 'CFLAGS=3D-O0 -g3' CPPFLAGS=3D-DGLYPH_DEBUG=
=3D1'




Acknowledgement sent to Drew Adams <drew.adams@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#15682; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 27 Apr 2016 17:30:03 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.